// Pins that control the motors controllers speed

int togglepin = 4;
int analogLeftSpeedPin = 5;
int analogRightSpeedPin = 6;


// Set Toggle to activated on start
int Toggle = 1;


// Buffer that contains the received bytes
// To have valid data, the buffer should be:
// Byte_0 Byte_0 Byte_LeftValue Byte_RightValue
// Think like that:
// If we get two sequential 0, we know the following two values are the speed of the fans
// Even if the fans speed is 0, you get 4 times 0
// This ensures that we get the correct bytes for left and right fans
// Also 0 is stopped fan, so no mixing whatever we get

// Output string <0><0><LWind><RWind> in Mover
// Start string <0><0><0><0>


byte bytesBuffer[4] = {0};

void setup() {

  // Start serial communication

  Serial.begin(115200, SERIAL_8N1);

  // Set pins as output

  pinMode(analogLeftSpeedPin, OUTPUT);

  pinMode(analogRightSpeedPin, OUTPUT);

  pinMode(togglepin, INPUT_PULLUP);  //Toggle switch

}


void loop() {

  if (digitalRead(togglepin) == LOW && Toggle == 0){
    Toggle = 1;
    delay (1000); //delay to prevent button push toggling rapidly
    //Serial.println("Toggle 1");
    //Serial.println(Toggle);
    
  }

    if (digitalRead(togglepin) == LOW && Toggle == 1){
    Toggle = 0;
    delay (1000); //delay to prevent button push toggling rapidly
    //Serial.println("Toggle 0");
    //Serial.println(Toggle);
  }

  if (Serial.available())

  {

    // Read new byte and put it at the end of the buffer

    bytesBuffer[0]=bytesBuffer[1];

    bytesBuffer[1]=bytesBuffer[2];

    bytesBuffer[2]=bytesBuffer[3];

    bytesBuffer[3] = Serial.read();

    //counter--;


    // Verify if we have a valid sequence

    if (Toggle == 1){ //Toggle button activated
      //Serial.println("Toggle Activated");

    if(bytesBuffer[0] == 0 && bytesBuffer[1] == 0)

    {

      // Set the pins values

      analogWrite(analogLeftSpeedPin, bytesBuffer[2]);

      analogWrite(analogRightSpeedPin, bytesBuffer[3]);

    }
    }
    if (Toggle == 0){  //Toggle deactivated
      analogWrite(analogLeftSpeedPin, 0000); //Turn fans to minimum when toggle has been pushed

      analogWrite(analogRightSpeedPin, 0000); //Turn fans to minimum when toggle has been pushed

      //Serial.println("Toggle Deactivated");

    }

  }}
